# Table

Tables allow you to display the output of APIs and scripts in rows and columns. Each object returned by the data source will create a row within the table. You can customize the columns of the table.&#x20;

## Selecting a Data Source

Both APIs and Scripts are supported by tables. When selecting an API, the API will be executed each time the page is loaded. When selecting a script, the last job run of the script will provide the output.&#x20;

![](/files/8JXC36vv9tUOLj2dz9WN)

When columns are not defined, all the properties of the objects will be displayed.&#x20;

![](/files/Bv2gmbBF9h2137YYEofY)

## Customizing Columns

You can customize the columns that are selected when displaying data.&#x20;

### Basic

Basic columns will select the properties defined and display the text.&#x20;

In this example, we are selecting the name and service type from a call to `Get-Service`.

![](/files/cNnn0AsCLuLfxhtL5wbx)

The resulting table only has these two properties displayed.&#x20;

![](/files/r1CziCBE3KCT14sa6Ngq)

### Buttons

Buttons can be added to columns to provide functionality for each row. Clicking the button will provide the target with the row data via the `$InputObject` parameter.&#x20;

![](/files/b4sb0WL9UZf5vwxwBRHO)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.powershelluniversal.com/v3/userinterfaces/pages/table.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
